
// user defined procedures
#include "snoopy.h"
#include "resource.h"
#include "procedures.h"

// standard libraries
#include <iostream>
#include <Commctrl.h>

#define TASKBAR_ICON_ID 1

using namespace std;

bool visible = false;
unsigned int taskbar_icon_message;
HMENU floating_menu;
Snoopy S;

// window procedure
LRESULT CALLBACK WindowProc(HWND hwnd,UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	try
	{
		switch(uMsg)
		{
			case WM_CREATE:
			{
				// create icon in taskbar status area
				{
					NOTIFYICONDATA info;
					extern HINSTANCE instance_handle;

					// register new window message - it will be used for taskbar status area icon
					taskbar_icon_message = RegisterWindowMessage(TEXT("TaskbarIcon"));
					if(taskbar_icon_message == 0)
						throw "Error in registering windows message";

					// initialize status area icon STRUCTURE PROPERTIES
					info.cbSize = sizeof(NOTIFYICONDATA); 
					info.hWnd = hwnd; 
					info.uID = TASKBAR_ICON_ID; 
					info.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP; 
					info.hIcon = LoadIcon(instance_handle,MAKEINTRESOURCE(IDI_ICON));
					info.uCallbackMessage = taskbar_icon_message;
					memcpy(info.szTip,TEXT("Snoopy - TCP/IP traffic sniffer"),strlen(TEXT("Snoopy - TCP/IP traffic sniffer"))+1);

					// send message to status area icon
					if(!Shell_NotifyIcon(NIM_ADD,&info))
						throw "Error in initializing status area icon";
				}

				// create floating menu
				{
					extern HINSTANCE instance_handle;

					// load floating menu
					floating_menu = LoadMenu (instance_handle,MAKEINTRESOURCE(IDR_MENU)) ;
					floating_menu = GetSubMenu (floating_menu, 0) ;
				}
			}
			return DefWindowProc(hwnd,uMsg,wParam,lParam);
			break;

			// some action on floating menu
			case WM_COMMAND:
			{
				switch(LOWORD(wParam))
				{
					// start sniffing
					case ID__START:
					{
						MessageBox(NULL,"start","",0);
					}
					break;

					// stop sniffing
					case ID__STOP:
					{
						MessageBox(NULL,"stop","",0);
					}
					break;

					// exit application
					case ID__EXIT:
					{
						NOTIFYICONDATA info;
						extern HINSTANCE instance_handle;

						// status area icon properties to be deleted
						info.cbSize = sizeof(NOTIFYICONDATA); 
						info.hWnd = hwnd; 
						info.uID = TASKBAR_ICON_ID; 
						info.uFlags = NIF_MESSAGE;

						// send message to status area icon
						if(!Shell_NotifyIcon(NIM_DELETE,&info))
							throw "Error in deleting icon from status area!";

						// exit application
						ExitProcess(0);
					}
					break;

					default:{}
				}
			}
			return 0;
			break;

			// no covered messages will be processed by default window procedure
			default:
			{
				if(uMsg == taskbar_icon_message)
				{
					if((UINT)lParam==WM_LBUTTONUP)
					{
						// show or hide ...
						if(visible)
							ShowWindow(hwnd,SW_SHOW);
						else
							ShowWindow(hwnd,SW_HIDE);

						// reverse visibility
						visible = !visible;
					}
					else
						if((UINT)lParam==WM_RBUTTONUP)
						{
							POINT point;

							// initialize object >point<

							ClientToScreen(hwnd,&point);

							TrackPopupMenu(floating_menu,TPM_RIGHTBUTTON,point.x,point.y,0,hwnd,NULL);
						}
						else
							return DefWindowProc(hwnd,uMsg,wParam,lParam);

					return 0;
				}
				else
					return DefWindowProc(hwnd,uMsg,wParam,lParam);
			}
		}
	}
	catch(string& msg)
	{
		// notify error
		MessageBox(GetDesktopWindow(),msg.c_str(),"Error occured",0);

		return FALSE;
	}
}
